#
# beenm-fishing.R, 16 Jan 22

library("colorspace")

pal_col=rainbow(3)

par(bty="l")
par(las=1)
par(pch="+")


bm=read.csv("ne.csv", as.is=TRUE)
plot(bm$day, cumsum(bm$new), col=pal_col[2],
	xaxs="i", yaxs="i",
	ylim=c(1, 3700), # 30000 for noun chunks
	xlab="Releases", ylab="Named entities (Cumulative)")
points(bm$day, cumsum(bm$total), col=pal_col[3])

legend(x="topleft", legend=c("Regression fits", "Total", "Unique"), bty="n", fill=pal_col, cex=1.2)

bm$csnew=cumsum(bm$new)
bm$cstotal=cumsum(bm$total)
bm_mod=glm(cstotal ~ day+I(day^2), data=bm)
summary(bm_mod)

# Call:
# glm(formula = cstotal ~ day + I(day^2), data = bm)
# 
# Deviance Residuals: 
#     Min       1Q   Median       3Q      Max  
# -80.688  -11.476    7.221   15.968   48.955  
# 
# Coefficients:
#               Estimate Std. Error t value Pr(>|t|)    
# (Intercept) -9.919e+00  1.272e+00  -7.798 8.03e-15 ***
# day          6.005e-01  1.531e-03 392.298  < 2e-16 ***
# I(day^2)     8.003e-05  3.862e-07 207.251  < 2e-16 ***
# ---
# Signif. codes:  0 ‘***’ 0.001 ‘**’ 0.01 ‘*’ 0.05 ‘.’ 0.1 ‘ ’ 1
# 
# (Dispersion parameter for gaussian family taken to be 690.7758)
# 
#     Null deviance: 3916528019  on 3838  degrees of freedom
# Residual deviance:    2649816  on 3836  degrees of freedom
# AIC: 35998
# 
# Number of Fisher Scoring iterations: 2
# 

lines(bm$day, predict(bm_mod), col=pal_col[1], lwd=3)
bmn_mod=glm(csnew ~ day+I(day^2), data=bm)
summary(bmn_mod)

# Call:
# glm(formula = csnew ~ day + I(day^2), data = bm)
# 
# Deviance Residuals: 
#     Min       1Q   Median       3Q      Max  
# -36.629   -8.640   -0.172    9.396   29.305  
# 
# Coefficients:
#               Estimate Std. Error t value Pr(>|t|)    
# (Intercept) -1.016e+01  6.575e-01  -15.45   <2e-16 ***
# day          4.625e-01  7.912e-04  584.53   <2e-16 ***
# I(day^2)    -8.559e-06  1.996e-07  -42.88   <2e-16 ***
# ---
# Signif. codes:  0 ‘***’ 0.001 ‘**’ 0.01 ‘*’ 0.05 ‘.’ 0.1 ‘ ’ 1
# 
# (Dispersion parameter for gaussian family taken to be 184.5781)
# 
#     Null deviance: 871429297  on 3838  degrees of freedom
# Residual deviance:    708042  on 3836  degrees of freedom
# AIC: 30932
# 
# Number of Fisher Scoring iterations: 2
# 

lines(bm$day, predict(bmn_mod), col=pal_col[1], lwd=3)
