#
# ner-training.py, 16 Jan 22
#
# code from: https://tecoholic.github.io/ner-annotator/

import json
import spacy


# load the training data
with open('se-annotations.json') as fp:
   training_data = json.load(fp)

# # prepare an empty model to train
# nlp = spacy.blank('en')
# nlp.vocab.vectors.name = 'demo'
# ner = nlp.create_pipe('ner')
# nlp.add_pipe(ner, last=True)

nlp = spacy.load("en_core_web_sm", disable=["parser", "tagger"])

# Add the custome NER Tags as entities into the model
for label in training_data["classes"]:
  nlp.entity.add_label(label)

# Train the model
optimizer = nlp.begin_training()

for text, annotations in training_data["annotations"]:
    if len(text) > 0: # in case an empty sentence was saved while annotating
        nlp.update([text], [annotations], sgd=optimizer)

nlp.to_disk("./se_ner")

